local Cryolysis2 = Cryolysis2
local L = AceLibrary("AceLocale-2.2"):new("Cryolysis2")
local candybar = AceLibrary("CandyBar-2.0")
local waterfall = AceLibrary("Waterfall-1.0")
local BS = AceLibrary("Babble-Spell-2.2")

------------------------------------------------------------------------------------------------------
-- Event registration function
------------------------------------------------------------------------------------------------------
function Cryolysis2:RegisterEvents()
	Cryolysis2:RegisterEvent("PLAYER_ENTERING_WORLD")
	Cryolysis2:RegisterEvent("BAG_UPDATE")
	Cryolysis2:RegisterEvent("PLAYER_REGEN_DISABLED")
	Cryolysis2:RegisterEvent("PLAYER_REGEN_ENABLED")
	Cryolysis2:RegisterEvent("MERCHANT_SHOW")
	Cryolysis2:RegisterEvent("MERCHANT_CLOSED")
	Cryolysis2:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
	Cryolysis2:RegisterEvent("SPELL_UPDATE_COOLDOWN")
	Cryolysis2:RegisterEvent("UNIT_SPELLCAST_SENT")
	Cryolysis2:RegisterEvent("LEARNED_SPELL_IN_TAB")
	Cryolysis2:RegisterEvent("TRADE_SHOW")
	Cryolysis2:RegisterEvent("TRADE_CLOSED")
	Cryolysis2:RegisterEvent("PLAYER_LOGIN")
	Cryolysis2:RegisterEvent("UNIT_MANA")
	Cryolysis2:RegisterEvent("UNIT_HEALTH")
	Cryolysis2:RegisterEvent("CHARACTER_POINTS_CHANGED")
	Cryolysis2:RegisterEvent("Cryo2_UpdateEvocationCooldown")
	Cryolysis2:RegisterEvent("Cryo2_UpdateManaGemCooldown")

	--Cryolysis2:RegisterEvent("CHAT_MSG_SPELL_PERIODIC_CREATURE_DAMAGE")
	--Cryolysis2:RegisterEvent("CHAT_MSG_SPELL_PERIODIC_SELF_BUFFS")
	--Cryolysis2:RegisterEvent("CHAT_MSG_SPELL_AURA_GONE_SELF")
	--Cryolysis2:RegisterEvent("CHAT_MSG_SPELL_AURA_GONE_OTHER")
	--Cryolysis2:RegisterEvent("CHAT_MSG_SPELL_BREAK_AURA")
	--Cryolysis2:RegisterEvent("CHAT_MSG_SPELL_SELF_DAMAGE")
	--Cryolysis2:RegisterEvent("UNIT_SPELLCAST_FAILED")
	--Cryolysis2:RegisterEvent("UNIT_SPELLCAST_INTERRUPTED")
	--Cryolysis2:RegisterEvent("UNIT_SPELLMISS")
	--Cryolysis2:RegisterEvent("PLAYER_TARGET_CHANGED")
end

------------------------------------------------------------------------------------------------------
-- BAG_UPDATE event
------------------------------------------------------------------------------------------------------
function Cryolysis2:BAG_UPDATE()

	Cryolysis2:UpdateWaterButton()
	Cryolysis2:UpdateFoodButton()
	Cryolysis2:EatAndDrinkUpdate()
	Cryolysis2:UpdateManaGemIcons()
	Cryolysis2:UpdateManaGemButton()
	Cryolysis2:ShowHideFeatherCount()
	Cryolysis2:ShowHideArcanePowderCount()

end


------------------------------------------------------------------------------------------------------
-- PLAYER_ENTERING_WORLD event
------------------------------------------------------------------------------------------------------
function Cryolysis2:PLAYER_ENTERING_WORLD()
	Cryolysis2:DetectSpellsAndRanks()
	Cryolysis2:SetupSphereAndButtons()
	Cryolysis2:UpdateAllButtonPositions()
	Cryolysis2:UpdateHideShow()
	Cryolysis2:UpdateHideShowMenus()
	Cryolysis2:UpdateHideShowSpellTimers()
	Cryolysis2:UpdateSphereAttributes()
	Cryolysis2:UpdateFoodButton()
	Cryolysis2:UpdateWaterButton()
	Cryolysis2:FindGroundMount()
	Cryolysis2:FindFlyingMount()
	Cryolysis2:UpdateMountButton()
	Cryolysis2:UpdateLeftButton(1)
	Cryolysis2:UpdateRightButton(1)
	Cryolysis2:UpdateBottomButton(1)
	Cryolysis2:UpdateLeftButton(2)
	Cryolysis2:UpdateRightButton(2)
	Cryolysis2:UpdateBottomButton(2)
	Cryolysis2:UpdateLeftButton(3)
	Cryolysis2:UpdateRightButton(3)
	Cryolysis2:UpdateBottomButton(3)
	Cryolysis2:UpdateManaGemButton()
	Cryolysis2:UpdateManaGemIcons()
	Cryolysis2:Cryo2_UpdateEvocationCooldown()
	Cryolysis2:Cryo2_UpdateManaGemCooldown()
	Cryolysis2:UpdateInnerSphere()
	Cryolysis2:UpdateOuterSphere()
	Cryolysis2:UpdateSpellMenu()
	Cryolysis2:UpdateBuffMenuAttributes()
	Cryolysis2:UpdateTeleAndPortButton()
	Cryolysis2:UpdatePortMenuAttributes()

	-- Register the Waterfall menu
	waterfall:Register('Cryo2Waterfall', 'aceOptions', Cryolysis2.options, 'title', 'Cryolysis 2')
	
end

------------------------------------------------------------------------------------------------------
-- PLAYER_REGEN_DISABLED event
------------------------------------------------------------------------------------------------------
function Cryolysis2:PLAYER_REGEN_DISABLED()
	Cryo2FoodButtonIcon:SetDesaturated(1)
	Cryo2WaterButtonIcon:SetDesaturated(1)
	Cryo2MountButtonIcon:SetDesaturated(1)
end

------------------------------------------------------------------------------------------------------
-- PLAYER_REGEN_ENABLED event
------------------------------------------------------------------------------------------------------
function Cryolysis2:PLAYER_REGEN_ENABLED()

	Cryolysis2:UpdateFoodButton()
	Cryolysis2:UpdateWaterButton()
	Cryo2MountButtonIcon:SetDesaturated(nil)
	Cryolysis2:UpdateManaGemButton()

end

------------------------------------------------------------------------------------------------------
-- MERCHANT_SHOW event
------------------------------------------------------------------------------------------------------
function Cryolysis2:MERCHANT_SHOW()

	local IsReagentVendor = false
	local ReagentsMissing = false
	
	if GetItemCount(L["Arcane Powder"]) < Cryolysis2.db.profile.RestockPowder or GetItemCount(L["Rune of Teleportation"]) < Cryolysis2.db.profile.RestockTeleport or GetItemCount(L["Rune of Portals"]) < Cryolysis2.db.profile.RestockPortals then
		ReagentsMissing = true
	end

	for i = 1, GetMerchantNumItems(), 1 do
		local name, texture, price, quantity, numAvailable, isUsable, extendedCost = GetMerchantItemInfo(i)
		if name == L["Arcane Powder"] or name == L["Rune of Teleportation"] or name == L["Rune of Portals"] then
			IsReagentVendor = true
			break;
		end
	end

	if IsReagentVendor and Cryolysis2.db.profile.Restock and ReagentsMissing then
		if Cryolysis2.db.profile.RestockConfirm then
			StaticPopup_Show("RESTOCK_REAGENTS")
		else
			Cryolysis2:RestockReagents()
		end
	end

end

------------------------------------------------------------------------------------------------------
-- MERCHANT_CLOSED event
------------------------------------------------------------------------------------------------------
function Cryolysis2:MERCHANT_CLOSED()

	StaticPopup_Hide("RESTOCK_REAGENTS")
	
end

------------------------------------------------------------------------------------------------------
-- UNIT_SPELLCAST_SUCCEEDED event
------------------------------------------------------------------------------------------------------
function Cryolysis2:UNIT_SPELLCAST_SUCCEEDED(unit, name, rank)

	if name == BS["Evocation"] then
		Cryolysis2:ScheduleEvent("Cryo2_UpdateEvocationCooldown", 0)
	end
	if name == BS["Conjure Mana Agate"] 
		or name == BS["Conjure Mana Jade"]
		or name == BS["Conjure Mana Citrine"]
		or name == BS["Conjure Mana Ruby"]
		or name == BS["Conjure Mana Emerald"]
	then
		Cryolysis2.Private.ManaGemCooldownBool = false
		Cryolysis2:ScheduleEvent("Cryo2_UpdateManaGemCooldown", 0)
	end
	
	Cryolysis2.Private.LastSpellCast = name

end

------------------------------------------------------------------------------------------------------
-- SPELL_UPDATE_COOLDOWN event
------------------------------------------------------------------------------------------------------
function Cryolysis2:SPELL_UPDATE_COOLDOWN(arg1)
	Cryolysis2:CreateCooldownTimer(Cryolysis2.Private.LastSpellCast)
end

------------------------------------------------------------------------------------------------------
-- UNIT_SPELLCAST_SENT event
------------------------------------------------------------------------------------------------------
function Cryolysis2:UNIT_SPELLCAST_SENT(caster, name, rank, target)
	
	if name == BS["Polymorph"] then
		-- Memorise the polymorph target
		Cryolysis2.Private.PolyTarget = target
	end
	
	Cryolysis2:RandomMessage(name, rank, target)
	
end

------------------------------------------------------------------------------------------------------
-- LEARNED_SPELL_IN_TAB event
------------------------------------------------------------------------------------------------------
function Cryolysis2:LEARNED_SPELL_IN_TAB()
	Cryolysis2:DetectSpellsAndRanks()
	Cryolysis2:UpdateSpellMenu()
	Cryolysis2:UpdateBuffMenuAttributes()
	Cryolysis2:UpdateTeleAndPortButton()
	Cryolysis2:UpdatePortMenuAttributes()
	Cryolysis2:UpdateManaGemButton()
	Cryolysis2:UpdateManaGemIcons()
	Cryolysis2:UpdateHideShow()
end

------------------------------------------------------------------------------------------------------
-- TRADE_SHOW event
------------------------------------------------------------------------------------------------------
function Cryolysis2:TRADE_SHOW()
	Cryolysis2.Private.TradeWindowOpen = true
end

------------------------------------------------------------------------------------------------------
-- TRADE_CLOSED event
------------------------------------------------------------------------------------------------------
function Cryolysis2:TRADE_CLOSED()

	Cryolysis2:UpdateFoodButton()
	Cryolysis2:UpdateWaterButton()
	Cryolysis2.Private.TradeWindowOpen = false

end

------------------------------------------------------------------------------------------------------
-- PLAYER_LOGIN event
------------------------------------------------------------------------------------------------------
function Cryolysis2:PLAYER_LOGIN()

	-----------------------------------------------------------------------------------
	-- DON'T MOVE THIS!!!!
	-- Checks to see if the character is a mage, if it's not it disables the addon
	local _, class = UnitClass("player")
	if class ~= "MAGE" then
		if Cryolysis2.db.profile.ClassWarn then
			StaticPopup_Show("CLASS_WARNING")
		end
		Cryolysis2:ToggleActive(false)
	end
	-----------------------------------------------------------------------------------

end

------------------------------------------------------------------------------------------------------
-- UNIT_MANA event
------------------------------------------------------------------------------------------------------
function Cryolysis2:UNIT_MANA(unit)
	if unit == "player" then
		if Cryolysis2.db.profile.InnerSphere == 2 or Cryolysis2.db.profile.InnerSphere == 3 or Cryolysis2.db.profile.InnerSphere == 6 or Cryolysis2.db.profile.InnerSphere == 7 then 
			Cryolysis2:UpdateInnerSphere()
		end
		if Cryolysis2.db.profile.OuterSphere == 3 then
			Cryolysis2:UpdateOuterSphere()
		end
	end
end

------------------------------------------------------------------------------------------------------
-- UNIT_HEALTH event
------------------------------------------------------------------------------------------------------
function Cryolysis2:UNIT_HEALTH(unit)
	if unit == "player" then
		if Cryolysis2.db.profile.InnerSphere == 2 or Cryolysis2.db.profile.InnerSphere == 3 or Cryolysis2.db.profile.InnerSphere == 4 or Cryolysis2.db.profile.InnerSphere == 5 then
			Cryolysis2:UpdateInnerSphere()
		end
		if Cryolysis2.db.profile.OuterSphere == 2 then
			Cryolysis2:UpdateOuterSphere()
		end
	end
end

------------------------------------------------------------------------------------------------------
-- CHARACTER_POINTS_CHANGED event
------------------------------------------------------------------------------------------------------
function Cryolysis2:CHARACTER_POINTS_CHANGED(value)

	if value == -1 then
	   Cryolysis2:UpdateBuffMenuAttributes() 
	end

end

------------------------------------------------------------------------------------------------------
-- Cryo2_UpdateEvocationCooldown event
------------------------------------------------------------------------------------------------------
function Cryolysis2:Cryo2_UpdateEvocationCooldown()
	
	if Cryolysis2.Private.HasEvocation == true then
		local start, duration, enabled = GetSpellCooldown(BS["Evocation"])
		if duration == 0 then	   -- Spell is not on cooldown
			if Cryolysis2.db.profile.ShowEvocationCooldownText then
				Cryo2EvocButtonText:SetText("")
			end
			if Cryolysis2.db.profile.InnerSphere == 9 then
				Cryo2MainSphereText:SetText(L["Ready"])
			end
			Cryo2EvocButtonIcon:SetDesaturated(nil)
			Cryolysis2:CancelScheduledEvent("Cryo2_UpdateEvocationCooldown")
		else	-- spell on cooldown
			local endtime = start + duration
			local timeleft = endtime - GetTime()
			local minutes = floor(timeleft/60)
			local seconds = floor(math.fmod(timeleft, 60))
			Cryo2EvocButtonIcon:SetDesaturated(1)
			if Cryolysis2.db.profile.ShowEvocationCooldownText then
				if minutes > 0 then
					if seconds < 10 then
						Cryo2EvocButtonText:SetText(minutes..":0"..seconds)
					else
						Cryo2EvocButtonText:SetText(minutes..":"..seconds)
					end
				else
					Cryo2EvocButtonText:SetText(floor(timeleft))
				end
			else
				Cryo2EvocButtonText:SetText("")
			end
			if Cryolysis2.db.profile.InnerSphere == 9 then
				if minutes > 0 then
					if seconds < 10 then
						Cryo2MainSphereText:SetText(minutes..":0"..seconds)
					else
						Cryo2MainSphereText:SetText(minutes..":"..seconds)
					end
				else
					Cryo2MainSphereText:SetText(floor(timeleft))
				end
			end
			Cryolysis2:ScheduleEvent("Cryo2_UpdateEvocationCooldown", 1)
		end
	end
end

------------------------------------------------------------------------------------------------------
-- Cryo2_UpdateManaGemCooldown event
------------------------------------------------------------------------------------------------------
function Cryolysis2:Cryo2_UpdateManaGemCooldown()
-- When BAG_UPDATE is fired, check the mage's bags against stored values of mana gems on-hand.
-- If the state of any of the gems has changed, then schedule this event to repeat.
	if Cryolysis2.Private.HighestManaGemOnHand > 0 then
		local start, duration, enabled = GetItemCooldown(Cryolysis2.Private.ManaGemName[Cryolysis2.Private.HighestManaGemOnHand])
		if duration == 0 then	   -- Spell is not on cooldown and a gem is conjured
			if Cryolysis2.db.profile.ShowManaGemCooldownText then
				Cryo2ManaGemButtonText:SetText("")
			end
			if Cryolysis2.db.profile.InnerSphere == 8 then
				Cryo2MainSphereText:SetText(L["Ready"])
			end
			Cryo2ManaGemButtonIcon:SetDesaturated(nil)
			Cryolysis2:CancelScheduledEvent("Cryo2_UpdateManaGemCooldown")
			Cryolysis2.Private.ManaGemCooldownBool = false
		else	-- Spell is on cooldown
			local endtime = start + duration
			local timeleft = endtime - GetTime()
			local minutes = floor(timeleft/60)
			local seconds = floor(math.fmod(timeleft, 60))
			Cryo2ManaGemButtonIcon:SetDesaturated(1)
			Cryolysis2.Private.ManaGemCooldownBool = true
			if Cryolysis2.db.profile.ShowManaGemCooldownText then
				if minutes > 0 then
					if seconds < 10 then
						Cryo2ManaGemButtonText:SetText(minutes..":0"..seconds)
					else
						Cryo2ManaGemButtonText:SetText(minutes..":"..seconds)
					end
				else
					Cryo2ManaGemButtonText:SetText(floor(timeleft))
				end
			else
				Cryo2ManaGemButtonText:SetText("")
			end
			if Cryolysis2.db.profile.InnerSphere == 8 then
				if minutes > 0 then
					if seconds < 10 then
						Cryo2MainSphereText:SetText(minutes..":0"..seconds)
					else
						Cryo2MainSphereText:SetText(minutes..":"..seconds)
					end
				else
					Cryo2MainSphereText:SetText(floor(timeleft))
				end
			end
			Cryolysis2:ScheduleEvent("Cryo2_UpdateManaGemCooldown", 1)
		end
	else -- no gems conjured
		if Cryolysis2.db.profile.ShowManaGemCooldownText then
			Cryo2ManaGemButtonText:SetText("")
		end
		if Cryolysis2.db.profile.InnerSphere == 8 then
			Cryo2MainSphereText:SetText(L["Unavailable"])
		end
		Cryo2ManaGemButtonIcon:SetDesaturated(1)
	end
end

------------------------------------------------------------------------------------------------------
-- Function for creating a cooldown timer
------------------------------------------------------------------------------------------------------
function Cryolysis2:CreateCooldownTimer(spellName)
	
	if spellName ~= nil then
		if spellName == BS["Cold Snap"] then
			TimerCompleted(BS["Ice Block"].."CD")
			TimerCompleted(BS["Frost Nova"].."CD")
			TimerCompleted(BS["Summon Water Elemental"].."CD")
			TimerCompleted(BS["Ice Barrier"].."CD")
			TimerCompleted(BS["Cone of Cold"].."CD")
			TimerCompleted(BS["Icy Veins"].."CD")
		end
	
		local start, duration, enabled = GetSpellCooldown(spellName)
		local active = Cryolysis2:TimerActive(spellName)
	
		if duration ~= nil then
			if duration > 1.5 and enabled ~= 0 and Cryolysis2.db.profile.ShowSpellTimers and not active then
			
				local color = Cryolysis2:FindSpellType(spellName)
				local texture = GetSpellTexture(spellName, BOOKTYPE_SPELL)
			
				if color == 1 then
					candybar:RegisterCandyBar(spellName.."CD", duration, spellName, texture, 0, 1, 0)
				end
				if color == 2 then
					candybar:RegisterCandyBar(spellName.."CD", duration, spellName, texture, 1, 0, 1)
				end
				if color == 3 then
					candybar:RegisterCandyBar(spellName.."CD", duration, spellName, texture, 1, 0, 0)
				end
				if color == 4 then
					candybar:RegisterCandyBar(spellName.."CD", duration, spellName, texture, 0, 0, 1)
				end

				candybar:SetCandyBarWidth(spellName.."CD", 150)
				candybar:RegisterCandyBarWithGroup(spellName.."CD", "Timers")
				table.insert(Cryolysis2.Private.SpellTimers, spellName.."CD")
				candybar:SetCandyBarCompletion(spellName.."CD", TimerCompleted, spellName.."CD")
				candybar:StartCandyBar(spellName.."CD", true)
			end
		end
	end
end

------------------------------------------------------------------------------------------------------
-- Set the hide/show attribute for the spell timers
------------------------------------------------------------------------------------------------------
function Cryolysis2:UpdateHideShowSpellTimers()
	if Cryolysis2.db.profile.ShowSpellTimers then
		Cryo2TimerFrame:Show()
	else
		Cryo2TimerFrame:Hide()
		for i = 1, #(Cryolysis2.Private.SpellTimers), 1 do
			TimerCompleted(Cryolysis2.Private.SpellTimers[i])
		end
	end
end

------------------------------------------------------------------------------------------------------
-- Function for ending a spell timer
------------------------------------------------------------------------------------------------------
function TimerCompleted(spellTimer)
	
	candybar:UnregisterCandyBar(spellTimer)
	
	for i = 1, #(Cryolysis2.Private.SpellTimers), 1 do
		if Cryolysis2.Private.SpellTimers[i] == spellTimer then
			table.remove(Cryolysis2.Private.SpellTimers, i)
			return
		end
	end
end

------------------------------------------------------------------------------------------------------
-- Function for checking whether or not a certain timer is active
------------------------------------------------------------------------------------------------------
function Cryolysis2:TimerActive(spellName)
	for i = 1, #(Cryolysis2.Private.SpellTimers), 1 do
		if Cryolysis2.Private.SpellTimers[i] == spellName.."CD" then
			return true
		end
	end
	return false
end






------------------------------------------------------------------------------------------------------
-- The following events are either useless or not yet implemented.
------------------------------------------------------------------------------------------------------


------------------------------------------------------------------------------------------------------
-- CHAT_MSG_SPELL_PERIODIC_CREATURE_DAMAGE event
------------------------------------------------------------------------------------------------------
function Cryolysis2:CHAT_MSG_SPELL_PERIODIC_CREATURE_DAMAGE(message)
	--Cryolysis2:Print("CHAT_MSG_SPELL_PERIODIC_CREATURE_DAMAGE: "..message)
end

------------------------------------------------------------------------------------------------------
-- CHAT_MSG_SPELL_PERIODIC_SELF_BUFFS event
------------------------------------------------------------------------------------------------------
function Cryolysis2:CHAT_MSG_SPELL_PERIODIC_SELF_BUFFS(message)
	--Cryolysis2:Print("CHAT_MSG_SPELL_PERIODIC_SELF_BUFFS: "..message)
end

------------------------------------------------------------------------------------------------------
-- CHAT_MSG_SPELL_AURA_GONE_SELF event
------------------------------------------------------------------------------------------------------
function Cryolysis2:CHAT_MSG_SPELL_AURA_GONE_SELF(message)
	--Cryolysis2:Print("CHAT_MSG_SPELL_AURA_GONE_Cryolysis2: "..message)
end

------------------------------------------------------------------------------------------------------
-- CHAT_MSG_SPELL_AURA_GONE_OTHER event
------------------------------------------------------------------------------------------------------
function Cryolysis2:CHAT_MSG_SPELL_AURA_GONE_OTHER(message)
	--Cryolysis2:Print("CHAT_MSG_SPELL_AURA_GONE_OTHER: "..message)
end

------------------------------------------------------------------------------------------------------
-- CHAT_MSG_SPELL_BREAK_AURA event
------------------------------------------------------------------------------------------------------
function Cryolysis2:CHAT_MSG_SPELL_BREAK_AURA(message)
	--Cryolysis2:Print("CHAT_MSG_SPELL_BREAK_AURA: "..message)
end

------------------------------------------------------------------------------------------------------
-- UNIT_SPELLCAST_FAILED event
------------------------------------------------------------------------------------------------------
function Cryolysis2:UNIT_SPELLCAST_FAILED()

end

------------------------------------------------------------------------------------------------------
-- UNIT_SPELLCAST_INTERRUPTED event
------------------------------------------------------------------------------------------------------
function Cryolysis2:UNIT_SPELLCAST_INTERRUPTED()

end

------------------------------------------------------------------------------------------------------
-- UNIT_SPELLMISS event
------------------------------------------------------------------------------------------------------
function Cryolysis2:UNIT_SPELLMISS(unitType, action)

	if action ~= "RESISTED" then
--~		-- Create debuff timer...scorch, winter's chill, frost nova, dragon's breath, blast wave, CoC
--~		if Cryolysis2.Private.LastSpellCast == "Scorch" then
--~		 
--~		end
--~		
--~		if Cryolysis2.Private.LastSpellCast == "Frostbolt" then
--~		if Cryolysis2.Private.LastSpellCast == "Scorch" then
--~		if Cryolysis2.Private.LastSpellCast == "Scorch" then
--~		if Cryolysis2.Private.LastSpellCast == "Scorch" then
--~		if Cryolysis2.Private.LastSpellCast == "Scorch" then
	end

end

------------------------------------------------------------------------------------------------------
-- CHAT_MSG_SPELL_SELF_DAMAGE event
------------------------------------------------------------------------------------------------------
function Cryolysis2:CHAT_MSG_SPELL_SELF_DAMAGE(message)

	--Cryolysis2:Print("CHAT_MSG_SPELL_SELF_DAMAGE: "..message)

end

------------------------------------------------------------------------------------------------------
-- PLAYER_TARGET_CHANGED event
------------------------------------------------------------------------------------------------------
function Cryolysis2:PLAYER_TARGET_CHANGED()

end